/**
  **********************************************************************************
  * @file      ebyte_port.h
  * @brief     EBYTEӲӿڲ ɿͻԼṩIOӿ
  * @details   μ https://www.ebyte.com/
  * @author    Weng
  * @date      2022-11-29
  * @version   1.0.0
  **********************************************************************************
  * @copyright BSD License
  *            ɶڰصӿƼ޹˾
  *   ______   ____   __     __  _______   ______
  *  |  ____| |  _ \  \ \   / / |__   __| |  ____|
  *  | |__    | |_) |  \ \_/ /     | |    | |__
  *  |  __|   |  _ <    \   /      | |    |  __|
  *  | |____  | |_) |    | |       | |    | |____
  *  |______| |____/     |_|       |_|    |______|
  *
  **********************************************************************************
  */
#include "ebyte_port.h"


/*= !!!ĿӲƽ̨ͷļ =======================================*/
#include "board.h"  //E15-EVB02 
/*==================================================================*/

/*!
 * @brief ĿӲƽ̨SPIӿշ
 *
 * @param send EBYTEϲҪ 1 Byte
 * @return SPIյ 1 Byte
 */
uint8e_t Ebyte_Port_SpiTransmitAndReceivce( uint8e_t send )
{
    uint8e_t result = 0;
    /*!ṩ: SPIӿ */
    result = Ebyte_BSP_SpiTransAndRecv( send );//ʾ
    return result;
}

/*!
 * @brief ĿӲƽ̨SPI_CS(NSS)
 *
 * @param cmd EBYTEϲĿָ
 *            @arg 0: CS(NSS)͵ƽ߼ź EBYTEģSPIӿΪ͵ƽѡ
 *            @arg 1: CS(NSS)ߵƽ߼ź
 */
void Ebyte_Port_SpiCsIoControl( uint8e_t cmd )
{
    if( cmd == 1 )
    {
        /* SPI CS ߵƽδѡ */
        Ebyte_BSP_RfSpiUnselected();//ʾ
    }
    else
    {
        /* SPI CS ͵ƽѡ */
        Ebyte_BSP_RfSpiSelected( );//ʾ
    }
}

/*!
 * @brief ĿӲƽ̨λ NRST ƺ
 *
 * @param cmd EBYTEϲĿָ
 *            @arg 0: NRST ͵ƽ߼ź
 *            @arg 1: NRST ߵƽ߼ź
 * @note EBYTEģNRSTΪ͵ƽλ
 */
//void Ebyte_Port_RstIoControl( uint8e_t cmd )
//{
//    if( cmd == 1 )
//    {
//        /*!ṩ: NRSTIO ߵƽ */
//    }
//    else
//    {
//        /*!ṩ: NRSTIO ͵ƽ */
//    }
//}

/*!
 * @brief (ѡ)ĿӲƽ̨ʹ TXEN ƺ
 *
 * @param cmd EBYTEϲĿָ
 *            @arg 0: TXEN ͵ƽ߼ź
 *            @arg 1: TXEN ߵƽ߼ź
 */
void Ebyte_Port_TxenIoControl( uint8e_t cmd )
{
    if( cmd == 1 )
    {
        /*!ѡ: ĿӲ·ӦTXENIO ߵƽ */
        //E29x_SetAntenna(ANTENNA_TXEN);
    }
    else
    {
        /*!ѡ: ĿӲ·ӦTXENIO ͵ƽ */
        //E29x_SetAntenna(ANTENNA_RXEN);
    }
}

/*!
 * @brief ĿӲƽ̨ʹ RXEN ƺ
 *
 * @param cmd EBYTEϲĿָ
 *            @arg 0: RXEN͵ƽ߼ź
 *            @arg 1: RXENߵƽ߼ź
 * @note EBYTEģRXENΪߵƽЧ
 */
void Ebyte_Port_RxenIoControl( uint8e_t cmd )
{
    if( cmd == 1 )
    {
        /*!ṩ: ĿӲ·ӦRXENIO ߵƽ */
        //E29x_SetAntenna(ANTENNA_RXEN);
    }
    else
    {
        /*!ṩ: ĿӲ·ӦRXENIO ͵ƽ */
        //E29x_SetAntenna(ANTENNA_TXEN);
    }
}

/*!
 * @brief ĿӲƽ̨ ͬIrqȡ
 */
uint8e_t Ebyte_Port_IrqIoRead( void )
{
    uint8e_t result = 0 ;
    /*!ṩ: ĿӲ·ӦDIO0 IO ״̬ȡ */
    result = Ebyte_BSP_E29IrqIoRead();//ʾ
    return result;
}

/*!
 * @brief ĿӲƽ̨ʱ
 *
 * @param time ʱ
 */
void Ebyte_Port_DelayMs( uint16e_t time )
{
    /*!ṩ: ʱ */
    uint16e_t i, n;
    while( time-- ) //ʾSTM8L 16MʱǰµĴʱ
    {
        for( i = 900; i > 0; i-- )
        {
            for( n = 1 ; n > 0 ; n-- )
            {
                asm( "nop" );
                asm( "nop" );
                asm( "nop" );
                asm( "nop" );
                asm( "nop" );
                asm( "nop" );
                asm( "nop" );
                asm( "nop" );
            }
        }
    }
}

/*!
 * @brief ĿӲƽ̨ʱ
 *
 * @param time ʱ΢
 */
void Ebyte_Port_DelayUs( uint16e_t time )
{
    /* !ṩ: ʱ */
    while( time-- ) //ʾSTM8L 16MʱǰµĴʱ
    {
        nop();
        nop();
        nop();
        nop();
    }
}


