#include "ebyte_e30x.h"

/* ʶģƵ */
#if defined(EBYTE_E30_900M20S)
//  #include "radio_config_850_2c.h"
//  #include "radio_config_850_1200.h"
  #include "radio_config_850_1200_c2a.h"
  #define EBYTE_E30_RF_ID  0x4463
  static uint8e_t E30x_NameString[] = "E30-900M20S";
#elif defined(EBYTE_E30_400M20S)
//  #define EBYTE_E30_RF_ID  0x4438 
  #define EBYTE_E30_RF_ID 0x4463
//  #include "radio_config_434_1b.h"
#include "radio_config_Si4463_420984522_w.h"


  static uint8e_t E30x_NameString[] = "E30-400M20S";
#endif

/* ʶ汾 */
#define EBYTE_E30_PROGRAM_TYPE 0x10

///ָڲFIFO
#define  FIFO_READ           0x00
#define  FIFO_WRITE          0x01

///ģʽл
#define  E30X_NOCHANGE            0x00
#define  E30X_SLEEP               0x01
#define  E30X_SPI_ACTIVE          0x02
#define  E30X_READY               0x03
#define  E30X_TX_TUNE             0x05
#define  E30X_RX_TUNE             0x06
#define  E30X_TX                  0x07
#define  E30X_RX                  0x08

uint8e_t E30x_GetIRQ( void );

typedef enum 
{
    GO_INIT          =0x00,        
    GO_BUSY          =0x01, 
    GO_STBY          =0x02,
    GO_RECEIVE       =0x03,
    GO_WAIT_RECEIVE  =0x04,       
    GO_TRANSMIT      =0x05,
    GO_WAIT_TRANSMIT =0x06,
    GO_SLEEP         =0x07,
    GO_ERROR         =0x08
}E30x_Status_t;

/// ״̬ʶ
static E30x_Status_t E30x_Status = GO_INIT;

static uint8e_t E30x_RxBuffer[64];

///WDSɵļ
const uint8e_t E30x_Config_WDS[] = RADIO_CONFIGURATION_DATA_ARRAY;

/*!
 * @brief жģǷ׼
 *
 * @return 0: 1:ʱ쳣
 * @note  ָͨREAD_CMD_BUFF(0x44)ʵָ֣ȡCTSź(0xFF)
 *        CTSΪ Clear To Send,ʾѾ׼Ӧ
 *        ʱ: ӲǷȷ
 *                  SPIͨǷȷ
 */
static uint8e_t E30x_IsReady( void )
{
    uint8e_t cts;
    uint8e_t result = 0;
    uint8e_t counter_1ms = 0;
    do
    {
        /* SPI CS ѡ */
        Ebyte_Port_SpiCsIoControl( 0 );
        /* 0x44ָ  READ_CMD_BUFF */
        Ebyte_Port_SpiTransmitAndReceivce( 0x44 );
        /* 㷢 Ӧ ӦȡCTS(0xFF) */
        cts = Ebyte_Port_SpiTransmitAndReceivce( 0xFF );
        /* SPI CS  */
        Ebyte_Port_SpiCsIoControl( 1 );
        /* ʱ 1 */
        counter_1ms++;
        Ebyte_Port_DelayMs( 1 );
    }
    while( ( cts != 0xFF ) && ( counter_1ms < 200 ) ); //ȡCTS(0xFF) 200볬ʱ ˳ѭ
    /* ֵж */
    if( counter_1ms >= 200 )
    {
        /* ʱ */
        result = 1;
    }
    return result;
}

/*!
 * @brief ģд빹ָ֡
 *
 * @param data  ָָ
 * @param size ָ鳤
 * @return 0: 1:ʱ
 */
static uint8e_t E30x_SendCommand( uint8e_t* data, uint8e_t size )
{
    uint8e_t result = 0;
    /* :ģǷ׼ */
    result = E30x_IsReady();
    if( result != 0 )
    {
        return 1;
    }
    /* SPI CS  */
    Ebyte_Port_SpiCsIoControl( 0 );
    /* д */
    while( size-- )
    {
        Ebyte_Port_SpiTransmitAndReceivce( *data++ );
    }
    
     Ebyte_Port_DelayMs( 1);
    /* SPI CS  */
    Ebyte_Port_SpiCsIoControl( 1 );
    return result;
}

/*!
 * @brief ģȡָ֡Ӧ
 *
 * @param data  ָ洢
 * @param size ȡ
 * @return 0: 1:ʱ
 */
static uint8e_t E30x_GetResponse( uint8e_t* data, uint8e_t size )
{
    uint8e_t result = 0;
    /* :ģǷ׼ */
    result = E30x_IsReady();
    if( result != 0 )
    {
        return 1;
    }
    /* SPI CS */
    Ebyte_Port_SpiCsIoControl( 0 );
    
    /* ָ:READ_CMD_BUFF(0x44)  */
    Ebyte_Port_SpiTransmitAndReceivce( 0x44 );
 
    /* ȡ */
    while( size-- )
    {
        *data++ = Ebyte_Port_SpiTransmitAndReceivce( 0xFF );
    }
    /* SPI CS */
    Ebyte_Port_SpiCsIoControl( 1 );
    return result;
}

/*!
 * @brief ù
 *
 * @param address Եı
 * @param data    ֵ
 * @return 0: 1:ʱ
 */
static uint8e_t E30x_SetProperty( uint16e_t address, uint8e_t data )
{
    uint8e_t result = 0;
    uint8e_t cmd[5];
    /* ָ:SET_PROPERTY(0x11) ʾ */
    cmd[0] = 0x11;
    cmd[1] = ( uint8e_t )( address >> 8 ); //    GROUP
    cmd[2] = 1;                      //д볤  NUM_PROPS
    cmd[3] = ( uint8e_t )address;    //ʼ    START_PROP
    cmd[4] = data;                   //дֵ
    /* д */
    result = E30x_SendCommand( cmd, 5 );
    return result;
}

static uint8e_t E30x_GetProperty( uint16e_t address )
{
    uint8e_t result = 0;
    uint8e_t cmd[4];

    cmd[0] = 0x12;
    cmd[1] = ( uint8e_t )( address >> 8 ); //    GROUP
    cmd[2] = 1;                      //д볤  NUM_PROPS
    cmd[3] = ( uint8e_t )address;    //ʼ    START_PROP

    /* д */
    result = E30x_SendCommand( cmd, 4 );
	
		E30x_GetResponse( cmd, 2 );
    return cmd[1];
}

/*!
 * @brief лģĹģʽ
 *
 * @param state ģʽ  οEZRadio_RevC2A API CHANGE_STATE½
 *        @arg  0:E30X_NOCHANGE
 *        @arg  1:E30X_SLEEP
 *        @arg  2:E30X_SPI_ACTIVE
 *        @arg  3:E30X_READY
 *
 *        @arg  5:E30X_TX_TUNE
 *        @arg  6:E30X_RX_TUNE
 *        @arg  7:E30X_TX
 *        @arg  8:E30X_RX
 *
 * @return 0: 1:лģʽʧ
 */
static uint8e_t E30x_SetWorkMode( uint8e_t state )
{
    uint8e_t cmd[3];
    uint8e_t i;
    uint8e_t result = 0;
    /* ָ:CHANGE_STATE(0x34) лģʽ */
    cmd[0] = 0x34;
    cmd[1] = state; //ģʽ
    /* д */
    result = E30x_SendCommand( cmd, 2 );

    if( result != 0 )
    {
        return 1;
    }
    /* ѭȷģʽ */
    for( i = 0 ; i < 5; i++ )
    {
        /* ָ:REQUEST_DEVICE_STATE(0x33) ǰ豸״̬ͨ */
        cmd[0] = 0x33;
        /* д */
        E30x_SendCommand( cmd, 1 );
   
        /* ȡָӦ */
        E30x_GetResponse( cmd, 3 );

        /* ȶģʽ */
        if( ( cmd[1] & 0x0F ) == state )
        {
            break;    //˳ѭ
        }
        Ebyte_Port_DelayMs( 1 );
    }
    /* ֵ */
    if( i >= 5 )
    {
        /* ģʽʧ */
        result = 1;
    }
    return result;
}

/*!
 * @brief FIFO
 * @param mode ģʽ
 *           @arg FIFO_WRITE ָFIFO
 *           @arg FIFO_READ  ָFIFO
 *
 * @return 0: 1:ʱ
 */
static uint8e_t E30x_ClearFIFO( uint8e_t mode )
{
    uint8e_t cmd[2];
    uint8e_t result;
    if( mode == FIFO_WRITE )
    {
        /* ָ:FIFO_INFO(0x15) 鿴FIFOFIFO */
        cmd[0] = 0x15;
        cmd[1] = 0x01;//÷FIFO
        result = E30x_SendCommand( cmd, 2 );
        if( result != 0 )
        {
            return 1;
        }
    }
    else
    {
        /* ָ:FIFO_INFO(0x15) 鿴FIFOFIFO */
        cmd[0] = 0x15;
        cmd[1] = 0x02;//ýFIFO
        result = E30x_SendCommand( cmd, 2 );
        if( result != 0 )
        {
            return 1;
        }
    }
    return result;
}

/*!
 * @brief дڲݶ
 *
 * @param data ָд
 * @param size ݳ
 *
 * @note ĬϽ/FIFOԶд󳤶Ϊ64ֽ (ȿռһλ)
 *       GLOBAL_CONFIG:FIFO_MODEãôFIFOϲҹд󳤶Ϊ129ֽ
 */
static void E30x_SetFIFO( uint8e_t* data, uint8e_t size )
{
    /* :ģǷ׼ */
    E30x_IsReady();
    /* SPI CS */
    Ebyte_Port_SpiCsIoControl( 0 );
    /* ָ:WRITE_TX_FIFO(0x66) дFIFO */
    Ebyte_Port_SpiTransmitAndReceivce( 0x66 );
    /* ʹݰ䳤ģʽ һֽдݳ */
    Ebyte_Port_SpiTransmitAndReceivce( size );
    /* ѭд */
    while( size -- )
    {
        Ebyte_Port_SpiTransmitAndReceivce( *data++ );
    }
    /* SPI CS */
    Ebyte_Port_SpiCsIoControl( 1 );
}

/*!
 * @brief ڲݶжȡյ
 *
 * @param data ָ洢
 * @param size ָȡĳ
 *
 * @note ĬϽ/FIFOԶȡ󳤶Ϊ64ֽ (ȿռһλ)
 *       GLOBAL_CONFIG:FIFO_MODEãôFIFOϲҹȡ󳤶Ϊ129ֽ
 */

void Ebyte_Port_Delay100US( uint16e_t time )
{
    /*!ṩ: ʱ */
  
    uint16e_t i,n;
    
    while(time--)//ʾSTM8L 16MʱǰµĴʱ 
    {
        for(i=20;i>0;i--)
        {
              for( n=1 ;n>0 ;n--)
              {
                  asm("nop"); 
                  asm("nop");
                  asm("nop");
                  asm("nop");
              }
        }
    }    
}
static uint8e_t E30x_GetFIFO( uint8e_t* data, uint8e_t* size )
{
    uint8e_t length;
    uint8e_t result ;
    /* ģǷ׼ */
    result = E30x_IsReady();
    if( result != 0 )
    {
        return 1;
    }
    /* SPI CS */
    Ebyte_Port_SpiCsIoControl( 0 );
    /* ָ:READ_RX_FIFO(0x77) FIFO  */
    Ebyte_Port_SpiTransmitAndReceivce( 0x77 );
    /* ɱ䳤ݰ ݵһֽΪ */
    length = Ebyte_Port_SpiTransmitAndReceivce( 0xFF );
    *size = length;
    /* ѭȡ */
    while( length-- )
    {
        *data++ = Ebyte_Port_SpiTransmitAndReceivce( 0xFF );
        Ebyte_Port_Delay100US(1);
    }
    /* SPI CS */
    Ebyte_Port_SpiCsIoControl( 1 );
    return result;
}

static uint8e_t ttio[10];
uint8e_t E30x_SetGPIO(void)
{
    uint8e_t cmd[10];
    /* ָ:GPIO_PIN_CFG(0x13)  */
    cmd[0] = 0x13;
    cmd[1] = 35;
    cmd[2] = 24;
    cmd[3] = 33|0x40;
    cmd[4] = 32|0x40;
    cmd[5] = 0;
    cmd[6] = 0;
    cmd[7] = 0;
    E30x_SendCommand(cmd, 8);
    E30x_GetResponse(ttio, 8);    
  return 0;
}


/*!
 * @brief ȡڲжϱʶ
 *
 * @return жͱ
 *        @arg 0x80:FILTER_MATCH_PEND
 *        @arg 0x40:FILTER_MISS_PEND
 *        @arg 0x20:PACKET_SENT_PEND   
 *        @arg 0x10:PACKET_RX_PEND     
 *        @arg 0x08:CRC_ERROR_PEND     CRCУ
 *        @arg 0x04:ALT_CRC_ERROR_PEND
 *        @arg 0x02:FIFO_ALMOST_EMPTY_PEND
 *        @arg 0x01:FIFO_ALMOST_FULL_PEND
 *
 */
uint8e_t E30x_GetIRQ( void )
{
    uint8e_t buffer[10];
    uint8e_t cmd[4];
    /* ָ:GET_INT_STATUS(0x20) ȡж״ָ̬ */
    cmd[0] = 0x20;
    cmd[1] = 0;  //PH_CLR_PEND    
    cmd[2] = 0;  //MODEM_CLR_PEND 
    cmd[3] = 0;  //CHIP_CLR_PEND  
    /* д */
    E30x_SendCommand( cmd, 4 );
    /* ָӦ */
    E30x_GetResponse( buffer, 9 );
    /* ֻȡ PH_PEND ֽеж״̬
       Բ EZRadio_revC2A_API GET_INT_STATUS½ ȡж״̬*/
    return  buffer[3];
}


/*!
 * @brief жģǷ
 *
 * @return 0: 1:쳣
 */
static uint8e_t E30x_IsExist( void )
{
    uint8e_t cmd[4];
    static uint8e_t buffer[10];    
    /* ָ:PART_INFO(0x01) ȡӲϢ */
    cmd[0] = 0x01;
    /* д */
    E30x_SendCommand( cmd, 1 );
    /* ָӦ */
    E30x_GetResponse( buffer, 9 ); 
    /*  еPARTϢ0x4463 */
    if( (buffer[2] == ((uint8e_t)(EBYTE_E30_RF_ID>>8)))
        && (buffer[3] == ((uint8e_t)(EBYTE_E30_RF_ID))) ) return 0;//
    
    return 1;
}

/*!
 * @brief λ
 * @note ģڲõĲᶪʧ
 */
void E30x_Reset( void )
{
    /* SDNøģ鸴λ */
    Ebyte_Port_SdnIoControl( 1 );
    /* ʱ */
    Ebyte_Port_DelayMs( 20 );
    /* SDN ָ */
    Ebyte_Port_SdnIoControl( 0 );
    /* CS ָ*/
    Ebyte_Port_SpiCsIoControl( 1 );
}



/*!
 * @brief ģ
 * @note Ҫԭ WDS 
 *       עE30ϵΪ26MHz
 *        ֱ滻radio_config.h 
 */
static void E30x_Config( void )
{
    uint8e_t i,temp;
    uint16e_t j = 0;
    /* WDSԶɵĲ  */
    const uint8e_t*  ptr = E30x_Config_WDS;
    /* дWDS */
    while( ( i = *( ptr + j ) ) != 0 )
    {
        j += 1;
        E30x_SendCommand( ( uint8e_t* )ptr + j, i );
        j += i;
    }
     
//    /*  ɱ䳤ݰ */
//    E30x_SetProperty( 0x1208, 0x2A ); //ģʽ 1BbyteֵFIFO 2ݰȿɱ
//    E30x_SetProperty( 0x1209, 0x01 ); //ݰȷڵ1
//    E30x_SetProperty( 0x120D, 0x00 ); //һ򳤶 ֽ
//    E30x_SetProperty( 0x120E, 0x01 ); //һ򳤶 ֽ 0x01:Ϊһֽ
//    E30x_SetProperty( 0x1211, 0x00 );
//    E30x_SetProperty( 0x1212, 0x10 );
//    /* 
//     * 뷶Χ:0x000x7F   Ĭֵ:0x7F
//     * ע;ʲ
//     * ӽֵʱС0.1db
//     * ƫʱܴ0.1db  */
//    E30x_SetProperty( 0x2201, 0x7F );
      temp = E30x_GetProperty( 0x0003 )|( 1<<4 );
      E30x_SetProperty( 0x0003, temp );
      
      E30x_SetProperty( 0x1206, 0x81 );
      E30x_SetProperty( 0x1209, 0x01 );
      E30x_SetProperty( 0x1208, 0x2A );
      E30x_SetProperty( 0x120A, 0x2A );
      E30x_SetProperty( 0x1221, 0x00 ); 
      E30x_SetProperty( 0x1222, 0x01 ); 
      E30x_SetProperty( 0x1223, 0x00 ); 
      E30x_SetProperty( 0x1224, 0x00 ); 
      
      E30x_SetProperty( 0x1225, 0x00 ); 
      E30x_SetProperty( 0x1226, 0x80 ); 
      E30x_SetProperty( 0x1227, 0x00 ); 
    /*  */
    E30x_SetGPIO();
    
   
}

/*!
 * @brief ʼ
 *
 * @return 0: 1:쳣
 */
uint8e_t E30x_GoReceive( void )
{
    uint8e_t result = 0;
    uint8e_t cmd[8];
    /* FIFO λ */
    result = E30x_ClearFIFO( FIFO_READ );
    if( result != 0 )
    {
        return 1;
    }
    E30x_ClearFIFO( FIFO_WRITE );
    /* лģʽ:  SPI_ACTIVE
     * ο  datasheet еĹģʽлͼ
     * ģʽΪ: SleepStby->SPI active->Ready->RxTune->Rx */
    result = E30x_SetWorkMode( E30X_SPI_ACTIVE );
 
    if( result != 0 )
    {
        return 1;
    }
    /* лģʽ:  RX_TUNE  Ԥ״̬ */
    result = E30x_SetWorkMode( E30X_RX_TUNE );
    if( result != 0 )
    {
        return 1;
    }
    /* ʼ() */
    cmd[0] = 0x32;      //ָ:START_RX (0x32) RxģʽʼƵ
    cmd[1] = 0;         //ŵ:   Ƶл
    cmd[2] = 0;         //:   ʱ̬ȴѶʱ
    cmd[3] = 0;         //ճ:   Byte
    cmd[4] = 0;         //ճ:   Byte
    cmd[5] = E30X_RX;   //ճʱ: лΪ״̬
    cmd[6] = E30X_RX;   //ճɹ: лΪ״̬
    cmd[7] = E30X_RX;   //ʧܺ: лΪ״̬
    E30x_SendCommand( cmd, 8 );
    
    /* ״̬¼ */
    E30x_Status = GO_WAIT_RECEIVE;
    
    return result;
}

/*!
 * @brief ʼ
 *
 * @param data ָ
 * @param size ݳ
 */
uint8e_t E30x_GoTransmit( uint8e_t* data, uint8e_t size )
{
    uint8e_t cmd[6];
    uint8e_t tx_size = size + 1;//ɱ䳤ݰ1ȱʾλ
    uint8e_t result = 1 ;
    /* ֹ */
    Ebyte_Port_DelayMs( 5 );
    /* FIFO λ */
    result = E30x_ClearFIFO( FIFO_READ );
    if( result != 0 )
    {
        return 1;
    }
    E30x_ClearFIFO( FIFO_WRITE );
    /* ģʽл: E30X_SPI_ACTIVE ģʽ
     * ο  datasheet еĹģʽлͼ
     * ģʽΪ: SleepStby->SPI active->Ready->TxTune->Tx */
    result = E30x_SetWorkMode( E30X_SPI_ACTIVE );
    if( result != 0 )
    {
        return 1;
    }
    /* FIFO д */
    E30x_SetFIFO( data, size );
    /* ģʽл: E30X_TX_TUNE Ԥģʽ */
    result = E30x_SetWorkMode( E30X_TX_TUNE );
    if( result != 0 )
    {
        return 1;
    }
    /* ʼ */
    cmd[0] = 0x31;         //ָ:START_TX(0x31) лΪTXģʽ ʼFIFOе
    cmd[1] = 0;            //ŵ:   Ƶл
    cmd[2] = 0;            //:   ʱʼͣȴѶʱҪɺԶģʽ ߿Ϊ 0x10
    cmd[3] = tx_size >> 8; //ͳ:   ֽ
    cmd[4] = tx_size;      //ͳ:   ֽ
    cmd[5] = 128;          //ʱ128us
    E30x_SendCommand( cmd, 6 );
    
    /* ״̬¼ */
    E30x_Status = GO_WAIT_TRANSMIT;
    
    /* ͷʽ ڴ˵ȴ */
    uint8e_t irqStatus = 0;
    do
    {
        irqStatus = E30x_GetIRQ();
    }
    while( !( irqStatus & 0x20 ) );
    
    /* ״̬¼ */
    E30x_Status = GO_STBY;
    
    /* صû */
    Ebyte_Port_TransmitCallback( 0x0001 );
    return 0 ;
}

/*!
 * @brief ģʽ
 */
uint8e_t E30x_GoSleep( void )
{
    uint8e_t result = E30x_SetWorkMode( E30X_SLEEP );
    if( result != 0 )
    {
        return 1;
    }
    return 0;
}

/*!
 * @brief ģʼ
 *
 * @return 0: 1:ʼʧ
 */
uint8e_t E30x_Init( void )
{
    uint8e_t result;
    /* λ */
    E30x_Reset();
    /* : SPIȡCTS ʧ Ӳ */
    result = E30x_IsReady();
    if( result != 0 ) return 1;
    /* : SPIȡID ʧ Ӳ */
    result = E30x_IsExist();
//    while(1)
//    {
//        E30x_IsExist();
//        E30x_IsExist();
//    }
    if( result != 0 ) return 1;  
    

    
    /*  */
    E30x_Config();
    /* ʼ */
    E30x_GoReceive();
    return result;
}

/*!
 * @brief ڵú ݽ
 *
 * @return 0
 * @note ҪѭãΪͨѯڲʶλжǷݵ
 *       жϣжеñ
 */
uint8e_t E30x_TaskForPoll( void )
{
    uint8e_t irqStatus ;
    /* ȡڲжϱʶ */
    irqStatus = E30x_GetIRQ();
    if( irqStatus == 0xFF)
      return 0;
    /* 0x10bit4 ʾݽжλ */
    if( irqStatus & 0x10 )
    {
        uint8e_t recvSize = 0;
        /* ȡ */
        E30x_GetFIFO( E30x_RxBuffer, &recvSize );
        
        /* ״̬¼ */
        E30x_Status = GO_STBY;
        
        /* صû */
        Ebyte_Port_ReceiveCallback( 0x0002, E30x_RxBuffer, recvSize );
    }
    return 0;
}

/*!
 * @brief 
 */
void E30x_TaskForIRQ( void )
{
}

/*!
 * @brief ȡģ
 *
 * @return ַָָ
 * @note ׼ַ ĩβн '\0'
 */
uint8e_t* E30x_GetName( void )
{
    return E30x_NameString;
}

/*!
 * @brief ȡģ汾
 *
 * @return 8λı
 * @note 0x10 V1.0
 */
uint8e_t E30x_GetDriverVersion( void )
{
    return  EBYTE_E30_PROGRAM_TYPE;
}

/*!
 * @brief ȡģ״̬
 * 
 * @return ״̬
 *        δʼ     GO_INIT          =0x00        
 *        л״̬ GO_BUSY          =0x01   
 *        /    GO_STBY          =0x02   
 *        ׼ջ GO_RECEIVE       =0x03   
 *        ڼ GO_WAIT_RECEIVE  =0x04          
 *        ׼ͻ GO_TRANSMIT      =0x05   
 *        ȴ GO_WAIT_TRANSMIT =0x06   
 *                 GO_SLEEP         =0x07   
 *        ڲ     GO_ERROR         =0x08 
 */
uint8e_t E30x_GetStatus(void)
{
  return (uint8e_t)E30x_Status;;
}